local minimizeAfterCombat=false
local slashOpts={}
local chan={}

MiniChat=AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceEvent-2.0","AceDB-2.0")
MiniChat:RegisterDB("MiniChatDB")
MiniChat:RegisterDefaults("profile",{
 ChatHeight=0,
 ChatLeft=0,
 ChatBottom=0,
 FontHeight=12,
 Minimized=false,
 Alpha=1.0,
 Clamped=true,
 Scale=1.0,
 Unlock=false,
 CustomX=0,
 CustomY=0,
 Position="topright",
 AnimationSpeed=0,
 Direction="down",
 MinimizedLines=1,
 AutoMinimize=false,
 AutoMinimizeAfter=60,
 AutoMaximizeEnabled=false,
 AutoMaximizeIgnoreIfInCombat=false,
 AutoMaximizeIgnoreSelf=false,
 AutoMaximizeOnYell=false,
 AutoMaximizeOnSay=false,
 AutoMaximizeOnWhisper=false,
 AutoMaximizeOnGuild=false,
 AutoMaximizeOnParty=false,
 AutoMaximizeOnRaid=false,
 AutoMaximizeOnBattleground=false,
 AutoMaximizeOnOfficer=false,
 AutoMaximizeOnChannel={}
})
waterfall=AceLibrary("Waterfall-1.0")

function MiniChat:UpdateOptions()
 slashOpts={
  type='group',
  args={
   alpha={
    type='range',
    name='Alpha value of MiniChat button',
    desc='Adjusts transparency of the MiniChat button.',
    usage="(0.0-1.0), 0=invisible, 1=opaque. Note: The button will always be opaque on mouse over.",
    step=0.1,
    get="GetAlpha",
    set="SetAlpha"
   },
   scale={
    type='range',
    name='Size of MiniChat button',
    desc='Adjusts the size of the MiniChat button.',
    usage='(0.1-2.0)',
    min=0.1,
    max=2.0,
    step=0.1,
    get="GetScale",
    set="SetScale"
   },
   clamped={
    type='toggle',
    name='Clamp MiniChat button to screen',
    desc='When active, the MiniChat button can\'t be moved out of the screen if unlocked.',
    get="GetClamped",
    set="SetClamped"
   },
   unlock={
    type='toggle',
    name='Unlock the MiniChat button',
    desc='Move the MiniChat button with your mouse. Note: Once moved, the button will never change it\'s position on min-/maximization until Position is set again.',
    get="GetUnlock",
    set="SetUnlock"
   },
   position={
    type='text',
    name='Position',
    desc='Sets the position of the MiniChat button.',
    usage="(topright|bottomright|bottomleft|topleft)",
    get="GetPosition",
    set="SetPosition",
    validate={"topright","bottomright","bottomleft","topleft"}
   },
   animationSpeed={
    type='range',
    name='Speed for min-/maximizing (0=no animation)',
    desc='Defines the speed for min-/maximizing the chat window.',
    usage='(0-100)',
    min=0,
    max=100,
    step=1,
    get="GetAnimationSpeed",
    set="SetAnimationSpeed"
   },
   direction={
    type='text',
    name='Direction',
    desc='Defines the direction which MiniChat minimizes to.',
    usage="(up|down)",
    get="GetDirection",
    set="SetDirection",
    validate={"up","down"}
   },
   minimizedLines={
    type='range',
    name='Minimized lines',
    desc='Defines the number of lines shown in minimized state.',
    usage="(1-5)",
    min=1,
    max=5,
    step=1,
    get="GetMinimizedLines",
    set="SetMinimizedLines"
   },
   autoMinimize={
    type='toggle',
    name='Auto minimize',
    desc='Minimizes the chat window automatically.',
    get="GetAutoMinimize",
    set="SetAutoMinimize"
   },
   autoMinimizeAfter={
    type='range',
    name='Auto minimize after',
    desc='Minimizes the chat window after x seconds.',
    usage="(5-600)",
    min=5,
    max=600,
    step=1,
    bigstep=10,
    get="GetAutoMinimizeAfter",
    set="SetAutoMinimizeAfter"
   },
   autoMaximize={
    type='group',
    name='Auto maximize',
    desc='Maximizes the chat window if certain message types are received. This does not ignore messages from muted channels.',
    args={
     enabled={
      type='toggle',
      name='Enabled',
      desc='Enables autoMaximize.',
      get="GetAutoMaximizeEnabled",
      set="SetAutoMaximizeEnabled"
     },
     ignoreSelf={
      type='toggle',
      name='Ignore your messages',
      desc='Don\'t maximize if messages are sent by you.',
      get="GetAutoMaximizeIgnoreSelf",
      set="SetAutoMaximizeIgnoreSelf"
     },
     ignoreIfInCombat={
      type='toggle',
      name='Suppress maximization while in combat.',
      desc='Chat won\'t maximize while in combat but maximization will be scheduled if important events happen during combat.',
      get="GetAutoMaximizeIgnoreIfInCombat",
      set="SetAutoMaximizeIgnoreIfInCombat"
     },
     onYell={
      type='toggle',
      name='on yell',
      desc='Maximizes the chat window when a yell (/y) is received.',
      get="GetAutoMaximizeOnYell",
      set="SetAutoMaximizeOnYell"
     },
     onSay={
      type='toggle',
      name='on say',
      desc='Maximizes the chat window whenever a message (/s) is received.',
      get="GetAutoMaximizeOnSay",
      set="SetAutoMaximizeOnSay"
     },
     onWhisper={
      type='toggle',
      name='on whisper',
      desc='Maximizes the chat window whenever a whisper (/w) is received.',
      get="GetAutoMaximizeOnWhisper",
      set="SetAutoMaximizeOnWhisper"
     },
     onGuild={
      type='toggle',
      name='on guild',
      desc='Maximizes the chat window whenever a guild message (/g) is received.',
      get="GetAutoMaximizeOnGuild",
      set="SetAutoMaximizeOnGuild"
     },
     onParty={
      type='toggle',
      name='on party',
      desc='Maximizes the chat window whenever a party message (/p) is received.',
      get="GetAutoMaximizeOnParty",
      set="SetAutoMaximizeOnParty"
     },
     onRaid={
      type='toggle',
      name='on raid',
      desc='Maximizes the chat window whenever a raid message (/ra) is received.',
      get="GetAutoMaximizeOnRaid",
      set="SetAutoMaximizeOnRaid"
     },
     onBattleground={
      type='toggle',
      name='on battleground',
      desc='Maximizes the chat window whenever a battleground message (/bg or battleground system message) is received.',
      get="GetAutoMaximizeOnBattleground",
      set="SetAutoMaximizeOnBattleground"
     },
     onOfficer={
      type='toggle',
      name='on officer',
      desc='Maximizes the chat window whenever an officer message (/o) is received.',
      get="GetAutoMaximizeOnOfficer",
      set="SetAutoMaximizeOnOfficer"
     },
     onChannel={
      type='group',
      name='on channel',
      desc='Maximizes the chat window whenever a message is received in custom channels.',
      args={
       channel01={
        type='toggle',
        name='01: '..tostring(chan[1]),
        desc='Enables autoMaximize for channel01',
        get="GetAutoMaximizeOnChannel1",
        set="SetAutoMaximizeOnChannel1"
       },
       channel02={
        type='toggle',
        name='02: '..tostring(chan[2]),
        desc='Enables autoMaximize for channel02',
        get="GetAutoMaximizeOnChannel2",
        set="SetAutoMaximizeOnChannel2"
       },
       channel03={
        type='toggle',
        name='03: '..tostring(chan[3]),
        desc='Enables autoMaximize for channel03',
        get="GetAutoMaximizeOnChannel3",
        set="SetAutoMaximizeOnChannel3"
       },
       channel04={
        type='toggle',
        name='04: '..tostring(chan[4]),
        desc='Enables autoMaximize for channel04',
        get="GetAutoMaximizeOnChannel4",
        set="SetAutoMaximizeOnChannel4"
       },
       channel05={
        type='toggle',
        name='05: '..tostring(chan[5]),
        desc='Enables autoMaximize for channel05',
        get="GetAutoMaximizeOnChannel5",
        set="SetAutoMaximizeOnChannel5"
       },
       channel06={
        type='toggle',
        name='06: '..tostring(chan[6]),
        desc='Enables autoMaximize for channel06',
        get="GetAutoMaximizeOnChannel6",
        set="SetAutoMaximizeOnChannel6"
       },
       channel07={
        type='toggle',
        name='07: '..tostring(chan[7]),
        desc='Enables autoMaximize for channel07',
        get="GetAutoMaximizeOnChannel7",
        set="SetAutoMaximizeOnChannel7"
       },
       channel08={
        type='toggle',
        name='08: '..tostring(chan[8]),
        desc='Enables autoMaximize for channel08',
        get="GetAutoMaximizeOnChannel8",
        set="SetAutoMaximizeOnChannel8"
       },
       channel09={
        type='toggle',
        name='09: '..tostring(chan[9]),
        desc='Enables autoMaximize for channel09',
        get="GetAutoMaximizeOnChannel9",
        set="SetAutoMaximizeOnChannel9"
       },
       channel10={
        type='toggle',
        name='10: '..tostring(chan[10]),
        desc='Enables autoMaximize for channel10',
        get="GetAutoMaximizeOnChannel10",
        set="SetAutoMaximizeOnChannel10"
       }
      }
     }
    }
   },
   gui={
    type='execute',
    guiHidden=true,
    name='GUI',
    desc='Opens GUI config.',
    func=function()
     waterfall:Open('MiniChat GUI')
    end
   }
  }
 }
 MiniChat:RegisterChatCommand("/mc","/minichat",slashOpts)
 waterfall:Register('MiniChat GUI','aceOptions',slashOpts,'title')
end

local MiniB=CreateFrame("Button",nil,UIParent)

function MiniChat:OnInitialize()
 for i=1,10 do
  local _,channelname=GetChannelName(i)
  if(channelname==nil) then
   chan[i]="-"
  else
   chan[i]=channelname
  end
 end
 self:UpdateOptions()
end

function MiniChat:OnDisable()
 MiniB:Hide()
end

function MiniChat:OnEnable()
 MiniB:SetFrameStrata("Low")
 MiniB:SetWidth(25*self:GetScale())
 MiniB:SetHeight(25*self:GetScale())
 MiniB:SetAlpha(self:GetAlpha())
 
 if(self:GetClamped()) then
  MiniB:SetClampedToScreen(true)
 end

 local MiniBTexture = MiniB:CreateTexture(nil,"BACKGROUND")
 MiniBTexture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-RotationRight-Big-Up.blp")
 MiniBTexture:SetAllPoints(MiniB)
 MiniB.texture = MiniBTexture

 self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE")
 self:RegisterEvent("MINICHAT_SMOOTHING")
 self:RegisterEvent("MINICHAT_AUTOMINIMIZE")
 self:RegisterEvent("CHAT_MSG_CHANNEL")
 self:RegisterEvent("CHAT_MSG_OFFICER")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL")
 self:RegisterEvent("CHAT_MSG_BATTLEGROUND")
 self:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
 self:RegisterEvent("UPDATE_WORLD_STATES")
 self:RegisterEvent("CHAT_MSG_PARTY")
 self:RegisterEvent("CHAT_MSG_RAID")
 self:RegisterEvent("CHAT_MSG_RAID_LEADER")
 self:RegisterEvent("CHAT_MSG_GUILD")
 self:RegisterEvent("CHAT_MSG_SAY")
 self:RegisterEvent("CHAT_MSG_WHISPER")
 self:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
 self:RegisterEvent("CHAT_MSG_YELL")
 self:RegisterEvent("PLAYER_REGEN_ENABLED")

 if(self.db.profile.AutoMinimize and not self.db.profile.Minimized) then
  self:MiniMax()
 end
 
 if(self:GetPosition()=="custom") then
  MiniB:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",self.db.profile.CustomX,self.db.profile.CustomY) 
 else
  MiniB:SetPoint("CENTER",DEFAULT_CHAT_FRAME,self.db.profile.Position,0,0)
 end
 MiniB:SetMovable(true)
 MiniB:Show()

 -- MouseDown on button
 MiniB:SetScript("OnMouseDown",function()
  MiniBTexture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-RotationRight-Big-Down.blp")
  if(self:GetUnlock()) then
   MiniB:StartMoving()
   self.db.profile.Position="custom"
  end
 end)
  -- MouseUp on button
 MiniB:SetScript("OnMouseUp",function()
  MiniBTexture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-RotationRight-Big-Up.blp")
  MiniB:StopMovingOrSizing()
  self.db.profile.CustomX=MiniB:GetLeft()
  self.db.profile.CustomY=MiniB:GetTop()
 end)

 -- Button clicked
 MiniB:SetScript("OnClick",function()
  self.db.profile.ChatLeft=DEFAULT_CHAT_FRAME:GetLeft()
  self.db.profile.ChatBottom=DEFAULT_CHAT_FRAME:GetBottom()
  local _,fontheight=DEFAULT_CHAT_FRAME:GetFont()
  self.db.profile.FontHeight=fontheight
  self:MiniMax()
 end)
 
 -- Mouse leaves button 
 MiniB:SetScript("OnLeave",function()
  MiniB:SetAlpha(self.db.profile.Alpha)
 end)
  -- Mouse is moved over button
 MiniB:SetScript("OnEnter",function()
  MiniB:SetAlpha(1)
 end)
end

function MiniChat:GetAlpha()
 return self.db.profile.Alpha
end
function MiniChat:SetAlpha(newAlpha)
 self.db.profile.Alpha=newAlpha
 MiniB:SetAlpha(newAlpha)
end


function MiniChat:GetScale()
 return self.db.profile.Scale
end
function MiniChat:SetScale(newScale)
 self.db.profile.Scale=newScale
 MiniB:SetWidth(25*newScale)
 MiniB:SetHeight(25*newScale)
end


function MiniChat:GetClamped()
 return self.db.profile.Clamped
end
function MiniChat:SetClamped(newClamped)
 self.db.profile.Clamped=newClamped
 MiniB:SetClampedToScreen(newClamped)
end


function MiniChat:GetUnlock()
 return self.db.profile.Unlock
end
function MiniChat:SetUnlock(newUnlock)
 self.db.profile.Unlock=newUnlock
end


function MiniChat:GetPosition()
 return self.db.profile.Position
end
function MiniChat:SetPosition(newPosition)
 self:SetUnlock(false)
 MiniB:ClearAllPoints()
 self.db.profile.Position=newPosition
 MiniB:SetPoint("CENTER",DEFAULT_CHAT_FRAME,newPosition,0,0)
end


function MiniChat:GetAnimationSpeed()
 return self.db.profile.AnimationSpeed
end
function MiniChat:SetAnimationSpeed(newAnimationSpeed)
 self.db.profile.AnimationSpeed=newAnimationSpeed
end


function MiniChat:GetDirection()
 return self.db.profile.Direction
end
function MiniChat:SetDirection(newDirection)
 self.db.profile.Direction=newDirection
 DEFAULT_CHAT_FRAME:ClearAllPoints()
 if(newDirection=="up") then
  DEFAULT_CHAT_FRAME:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",DEFAULT_CHAT_FRAME:GetLeft(),DEFAULT_CHAT_FRAME:GetTop())
 else
  DEFAULT_CHAT_FRAME:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",DEFAULT_CHAT_FRAME:GetLeft(),DEFAULT_CHAT_FRAME:GetBottom())
 end
end


function MiniChat:GetMinimizedLines()
 return self.db.profile.MinimizedLines
end
function MiniChat:SetMinimizedLines(newMinimizedLines)
 self.db.profile.MinimizedLines=newMinimizedLines
end

function MiniChat:GetAutoMinimize()
 return self.db.profile.AutoMinimize
end
function MiniChat:SetAutoMinimize(newAutoMinimize)
 self.db.profile.AutoMinimize=newAutoMinimize
end
function MiniChat:GetAutoMinimizeAfter()
 return self.db.profile.AutoMinimizeAfter
end
function MiniChat:SetAutoMinimizeAfter(newAutoMinimizeAfter)
 self.db.profile.AutoMinimizeAfter=newAutoMinimizeAfter
end

function MiniChat:GetAutoMaximizeEnabled()
 return self.db.profile.AutoMaximizeEnabled
end
function MiniChat:SetAutoMaximizeEnabled(newAutoMaximizeEnabled)
 self.db.profile.AutoMaximizeEnabled=newAutoMaximizeEnabled
end

function MiniChat:GetAutoMaximizeIgnoreIfInCombat()
 return self.db.profile.AutoMaximizeIgnoreIfInCombat
end
function MiniChat:SetAutoMaximizeIgnoreIfInCombat(newAutoMaximizeIgnoreIfInCombat)
 self.db.profile.AutoMaximizeIgnoreIfInCombat=newAutoMaximizeIgnoreIfInCombat
end
function MiniChat:GetAutoMaximizeIgnoreSelf()
 return self.db.profile.AutoMaximizeIgnoreSelf
end
function MiniChat:SetAutoMaximizeIgnoreSelf(newAutoMaximizeIgnoreSelf)
 self.db.profile.AutoMaximizeIgnoreSelf=newAutoMaximizeIgnoreSelf
end
function MiniChat:GetAutoMaximizeOnYell()
 return self.db.profile.AutoMaximizeOnYell
end
function MiniChat:SetAutoMaximizeOnYell(newAutoMaximizeOnYell)
 self.db.profile.AutoMaximizeOnYell=newAutoMaximizeOnYell
end
function MiniChat:GetAutoMaximizeOnSay()
 return self.db.profile.AutoMaximizeOnSay
end
function MiniChat:SetAutoMaximizeOnSay(newAutoMaximizeOnSay)
 self.db.profile.AutoMaximizeOnSay=newAutoMaximizeOnSay
end
function MiniChat:GetAutoMaximizeOnWhisper()
 return self.db.profile.AutoMaximizeOnWhisper
end
function MiniChat:SetAutoMaximizeOnWhisper(newAutoMaximizeOnWhisper)
 self.db.profile.AutoMaximizeOnWhisper=newAutoMaximizeOnWhisper
end
function MiniChat:GetAutoMaximizeOnGuild()
 return self.db.profile.AutoMaximizeOnGuild
end
function MiniChat:SetAutoMaximizeOnGuild(newAutoMaximizeOnGuild)
 self.db.profile.AutoMaximizeOnGuild=newAutoMaximizeOnGuild
end
function MiniChat:GetAutoMaximizeOnParty()
 return self.db.profile.AutoMaximizeOnParty
end
function MiniChat:SetAutoMaximizeOnParty(newAutoMaximizeOnParty)
 self.db.profile.AutoMaximizeOnParty=newAutoMaximizeOnParty
end
function MiniChat:GetAutoMaximizeOnRaid()
 return self.db.profile.AutoMaximizeOnRaid
end
function MiniChat:SetAutoMaximizeOnRaid(newAutoMaximizeOnRaid)
 self.db.profile.AutoMaximizeOnRaid=newAutoMaximizeOnRaid
end
function MiniChat:GetAutoMaximizeOnBattleground()
 return self.db.profile.AutoMaximizeOnBattleground
end
function MiniChat:SetAutoMaximizeOnBattleground(newAutoMaximizeOnBattleground)
 self.db.profile.AutoMaximizeOnBattleground=newAutoMaximizeOnBattleground
end
function MiniChat:GetAutoMaximizeOnOfficer()
 return self.db.profile.AutoMaximizeOnOfficer
end
function MiniChat:SetAutoMaximizeOnOfficer(newAutoMaximizeOnOfficer)
 self.db.profile.AutoMaximizeOnOfficer=newAutoMaximizeOnOfficer
end
function MiniChat:GetAutoMaximizeOnChannel1()
 return self.db.profile.AutoMaximizeOnChannel[1]
end
function MiniChat:SetAutoMaximizeOnChannel1(newAutoMaximizeOnChannel1)
 self.db.profile.AutoMaximizeOnChannel[1]=newAutoMaximizeOnChannel1
end
function MiniChat:GetAutoMaximizeOnChannel2()
 return self.db.profile.AutoMaximizeOnChannel[2]
end
function MiniChat:SetAutoMaximizeOnChannel2(newAutoMaximizeOnChannel2)
 self.db.profile.AutoMaximizeOnChannel[2]=newAutoMaximizeOnChannel2
end
function MiniChat:GetAutoMaximizeOnChannel3()
 return self.db.profile.AutoMaximizeOnChannel[3]
end
function MiniChat:SetAutoMaximizeOnChannel3(newAutoMaximizeOnChannel3)
 self.db.profile.AutoMaximizeOnChannel[3]=newAutoMaximizeOnChannel3
end
function MiniChat:GetAutoMaximizeOnChannel4()
 return self.db.profile.AutoMaximizeOnChannel[4]
end
function MiniChat:SetAutoMaximizeOnChannel4(newAutoMaximizeOnChannel4)
 self.db.profile.AutoMaximizeOnChannel[4]=newAutoMaximizeOnChannel4
end
function MiniChat:GetAutoMaximizeOnChannel5()
 return self.db.profile.AutoMaximizeOnChannel[5]
end
function MiniChat:SetAutoMaximizeOnChannel5(newAutoMaximizeOnChannel5)
 self.db.profile.AutoMaximizeOnChannel[5]=newAutoMaximizeOnChannel5
end
function MiniChat:GetAutoMaximizeOnChannel6()
 return self.db.profile.AutoMaximizeOnChannel[6]
end
function MiniChat:SetAutoMaximizeOnChannel6(newAutoMaximizeOnChannel6)
 self.db.profile.AutoMaximizeOnChannel[6]=newAutoMaximizeOnChannel6
end
function MiniChat:GetAutoMaximizeOnChannel7()
 return self.db.profile.AutoMaximizeOnChannel[7]
end
function MiniChat:SetAutoMaximizeOnChannel7(newAutoMaximizeOnChannel7)
 self.db.profile.AutoMaximizeOnChannel[7]=newAutoMaximizeOnChannel7
end
function MiniChat:GetAutoMaximizeOnChannel8()
 return self.db.profile.AutoMaximizeOnChannel[8]
end
function MiniChat:SetAutoMaximizeOnChannel8(newAutoMaximizeOnChannel8)
 self.db.profile.AutoMaximizeOnChannel[8]=newAutoMaximizeOnChannel8
end
function MiniChat:GetAutoMaximizeOnChannel9()
 return self.db.profile.AutoMaximizeOnChannel[9]
end
function MiniChat:SetAutoMaximizeOnChannel9(newAutoMaximizeOnChannel9)
 self.db.profile.AutoMaximizeOnChannel[9]=newAutoMaximizeOnChannel9
end
function MiniChat:GetAutoMaximizeOnChannel10()
 return self.db.profile.AutoMaximizeOnChannel[10]
end
function MiniChat:SetAutoMaximizeOnChannel10(newAutoMaximizeOnChannel10)
 self.db.profile.AutoMaximizeOnChannel[10]=newAutoMaximizeOnChannel10
end


function MiniChat:MiniMax()
 self.db.profile.ChatLeft=DEFAULT_CHAT_FRAME:GetLeft()
 self.db.profile.ChatBottom=DEFAULT_CHAT_FRAME:GetBottom()
 if(not self.db.profile.Minimized) then -- maximized
  self.db.profile.ChatHeight=DEFAULT_CHAT_FRAME:GetHeight()
  expand=false
  if(self.db.profile.AnimationSpeed==0) then
   DEFAULT_CHAT_FRAME:SetHeight((self.db.profile.MinimizedLines+0.1)*self.db.profile.FontHeight)
  end
  if(self.db.profile.Direction=="down") then
   DEFAULT_CHAT_FRAME:ClearAllPoints()
   DEFAULT_CHAT_FRAME:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft,self.db.profile.ChatBottom)
  end
 self.db.profile.Minimized=true
 self:CancelAllScheduledEvents()
 else -- minimized
  expand=true
  if(self.db.profile.AnimationSpeed==0) then
   DEFAULT_CHAT_FRAME:SetHeight(self.db.profile.ChatHeight)
  end
  if(self.db.profile.Direction=="down") then   
   DEFAULT_CHAT_FRAME:ClearAllPoints()
   DEFAULT_CHAT_FRAME:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft,self.db.profile.ChatBottom)
  end
  self.db.profile.Minimized=false
  if(self.db.profile.AutoMinimize) then
   self:ScheduleEvent("minichatautominimize","MINICHAT_AUTOMINIMIZE",self.db.profile.AutoMinimizeAfter)
  end
 end
 if(self.db.profile.AnimationSpeed>0) then
  MiniB:Hide()
  self:ScheduleEvent("minichatsmoothing","MINICHAT_SMOOTHING",0.025,expand)
 else
  DEFAULT_CHAT_FRAME:ScrollDown()
 end
end

function MiniChat:CHAT_MSG_CHANNEL_NOTICE()
 if(arg1=="YOU_JOINED") then
  chan[arg8]=arg9
 else -- "YOU_LEFT"
  local _,channelname=GetChannelName(arg8)
  if(channelname==nil) then
   chan[arg8]="-"
  else
   chan[arg8]=arg9
  end
 end
 self:UpdateOptions()
end

function MiniChat:PLAYER_REGEN_ENABLED()
 if(maximizeAfterCombat) then
  maximizeAfterCombat=false
  if(self.db.profile.Minimized) then
   self:MiniMax()
  end
 end
end

function MiniChat:CHAT_MSG_CHANNEL(_,author,_,_,_,_,_,nr)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnChannel[nr])
end
function MiniChat:CHAT_MSG_YELL(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnYell)
end
function MiniChat:CHAT_MSG_SAY(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnSay)
end
function MiniChat:CHAT_MSG_WHISPER(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnWhisper)
end
function MiniChat:CHAT_MSG_WHISPER_INFORM()
 if(self.db.profile.AutoMaximizeIgnoreSelf) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnWhisper)
end
function MiniChat:CHAT_MSG_GUILD(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnGuild)
end
function MiniChat:CHAT_MSG_PARTY(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnParty)
end
function MiniChat:CHAT_MSG_RAID(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnRaid)
end
function MiniChat:CHAT_MSG_RAID_LEADER(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnRaid)
end
function MiniChat:CHAT_MSG_BATTLEGROUND(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_BATTLEGROUND_LEADER(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_BG_SYSTEM_ALLIANCE()
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_BG_SYSTEM_HORDE()
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_BG_SYSTEM_NEUTRAL()
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:UPDATE_WORLD_STATES()
 self:CatchMessage(self.db.profile.AutoMaximizeOnBattleground)
end
function MiniChat:CHAT_MSG_OFFICER(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 self:CatchMessage(self.db.profile.AutoMaximizeOnOfficer)
end
function MiniChat:CatchMessage(msgtypeenabled)
 if(self.db.profile.AutoMaximizeEnabled and msgtypeenabled) then
  if(self.db.profile.AutoMaximizeIgnoreIfInCombat and UnitAffectingCombat("player")) then
   maximizeAfterCombat=true
   return
  end
  if(self.db.profile.AutoMinimize) then
    if(self:IsEventScheduled("minichatautominimize")) then
     self:CancelScheduledEvent("minichatautominimize")
    end
    self:ScheduleEvent("minichatautominimize","MINICHAT_AUTOMINIMIZE",self.db.profile.AutoMinimizeAfter)
  end
  if(self.db.profile.Minimized) then
   self:MiniMax()
  end
 end
end

function MiniChat:MINICHAT_AUTOMINIMIZE()
 if(not self.db.profile.Minimized) then
  self:MiniMax()
 end
end

function MiniChat:MINICHAT_SMOOTHING(expand)
 local lower=floor((self.db.profile.MinimizedLines+0.1)*self.db.profile.FontHeight)
 if(expand) then
  DEFAULT_CHAT_FRAME:SetHeight(math.floor(DEFAULT_CHAT_FRAME:GetHeight()+2+self.db.profile.AnimationSpeed*DEFAULT_CHAT_FRAME:GetHeight()/120))
  if(DEFAULT_CHAT_FRAME:GetHeight()>self.db.profile.ChatHeight) then
   DEFAULT_CHAT_FRAME:SetHeight(self.db.profile.ChatHeight)
  end
 else
  DEFAULT_CHAT_FRAME:SetHeight(math.ceil(DEFAULT_CHAT_FRAME:GetHeight()-2-self.db.profile.AnimationSpeed*DEFAULT_CHAT_FRAME:GetHeight()/120))
  if(DEFAULT_CHAT_FRAME:GetHeight()<lower) then
   DEFAULT_CHAT_FRAME:SetHeight(lower)
  end
 end
 if(self.db.profile.Direction=="down") then
  DEFAULT_CHAT_FRAME:ClearAllPoints()
  DEFAULT_CHAT_FRAME:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft,self.db.profile.ChatBottom)
 end
 if((DEFAULT_CHAT_FRAME:GetHeight()>lower and not expand)
    or
    (DEFAULT_CHAT_FRAME:GetHeight()<self.db.profile.ChatHeight and expand)) then
  self:ScheduleEvent("minichatsmoothing","MINICHAT_SMOOTHING",0.025,expand)
 else
  DEFAULT_CHAT_FRAME:ScrollDown()
  MiniB:Show()
 end
end